/// <reference types="express" />
import { Serializer, QuerySelect, DbHelperModel } from 'ts-db-helper';
import { TRFRequest } from '../interface/request.interface';
import { Response } from 'express';
export declare abstract class ViewSet<T extends DbHelperModel> {
    abstract model: {
        new (): T;
    };
    query: QuerySelect<T>;
    serializer: {
        new (a?: any, b?: any, c?: any): Serializer<T>;
    };
    constructor();
    search(req: TRFRequest, resp: Response): void;
    list(req: TRFRequest, resp: Response): void;
    retrieve(req: TRFRequest, resp: Response): void;
    create(req: TRFRequest, resp: Response): void;
    update(req: TRFRequest, resp: Response): void;
    partialUpdate(req: TRFRequest, resp: Response): void;
    delete(req: TRFRequest, resp: Response): void;
    private retrieveOrDelete(req, resp, retreive);
    private getSerializerInstance(target, many?);
    private persist(req, resp, create, partial?);
}
