import { RouteBundle } from '../internal/route-bundle';
import { RouteManager } from '../managers/route.manager';
function endPointFactory(method, config) {
    return function (target, propertyKey, descriptor) {
        var bundle = RouteManager.getInstance().getRouteBundle(target);
        if (!bundle) {
            bundle = new RouteBundle();
            RouteManager.getInstance().addRouteBundle(target, bundle);
        }
        config.method = method;
        bundle.routes[propertyKey] = config;
    };
}
export function Get(config) {
    return endPointFactory('get', config);
}
export function Post(config) {
    return endPointFactory('post', config);
}
export function Put(config) {
    return endPointFactory('put', config);
}
export function Patch(config) {
    return endPointFactory('patch', config);
}
export function Delete(config) {
    return endPointFactory('delete', config);
}
export function Options(config) {
    return endPointFactory('options', config);
}
export function Head(config) {
    return endPointFactory('head', config);
}
export function Connect(config) {
    return endPointFactory('connect', config);
}
export function Trace(config) {
    return endPointFactory('trace', config);
}
export function All(config) {
    return endPointFactory('all', config);
}
//# sourceMappingURL=end-points.decorator.js.map