/// <reference types="express" />
import { DbHelperModel } from 'ts-db-helper';
import { EndPointConfigurator } from '../configurators/end-point.configurator';
import { IAuthFilter } from '../interface/auth-filter.interface';
import { IAuthPermission } from '../interface/auth-permission.interface';
import { IUserModel } from '../interface/user-model.interface';
import { RouteConfigurator } from '../configurators/route.configurator';
import { ViewSet } from '../base/viewset';
import { IPermissionFilter } from '../interface/permission-filter.interface';
import * as express from 'express';
export declare class EndPointBuilder {
    static userModel: IUserModel;
    static authFilters: IAuthFilter[];
    static defaultAuthPermission: IAuthPermission;
    static defaultPermissionFilter: IPermissionFilter;
    static build(mViewset: {
        new (): ViewSet<DbHelperModel>;
    }, key: string, routeConfig: RouteConfigurator, endPointConfig: EndPointConfigurator, router: express.Router): Function;
    private static manageEndPointError(req, resp, err);
    private static manageEndPointAuthFilter(req, resp, routeConfig, endPointConfig, viewset, key);
    private static callEndPointAuthFilter(req, routeConfig, endPointConfig);
    private static scanAuthFilters(req, edpFilters, index?);
    private static manageEndPointAuthPermission(req, resp, routeConfig, endPointConfig, viewset, key);
    private static callAuthPermissions(req, routeConfig, endPointConfig);
    private static manageEndPointPermissions(req, resp, routeConfig, endPointConfig, viewset, key);
    private static callPermissions(req, routeConfig, endPointConfig);
    private static scanPermissionFilters(req, permissionFilters, index);
}
