var RouteManager = /** @class */ (function () {
    function RouteManager() {
        this.bundles = {};
        this.namespacies = {};
    }
    RouteManager.getInstance = function () {
        if (!RouteManager.instance) {
            RouteManager.instance = new RouteManager();
        }
        return RouteManager.instance;
    };
    RouteManager.prototype.addRouteBundle = function (viewSet, bundle) {
        if (this.bundles.hasOwnProperty(viewSet.name || viewSet.constructor.name)) {
            throw new Error('Duplicate adding viewSet to route manager');
        }
        this.bundles[viewSet.name || viewSet.constructor.name] = bundle;
    };
    RouteManager.prototype.getRouteBundle = function (viewSet) {
        return this.bundles[viewSet.name || viewSet.constructor.name];
    };
    RouteManager.prototype.addNamespaceConfiguration = function (namespace, config) {
        if (this.bundles.hasOwnProperty(namespace.name)) {
            throw new Error('Duplicate adding viewSet to route manager');
        }
        this.namespacies[namespace.name] = config || null;
    };
    RouteManager.prototype.getNamespaceConfiguration = function (namespace) {
        var config = this.namespacies[namespace.name];
        if (config) {
            return config;
        }
        else {
            throw new Error('Namespace "' + namespace.name + '" is not correctly declared, did you use @Namespace ?');
        }
    };
    RouteManager.prototype.isRegisteredNamespace = function (namespace) {
        return this.namespacies.hasOwnProperty(namespace.name);
    };
    RouteManager.prototype.isRegisteredViewset = function (viewset) {
        return this.bundles.hasOwnProperty(viewset.name);
    };
    return RouteManager;
}());
export { RouteManager };
//# sourceMappingURL=route.manager.js.map