import { BasicAuthFilter } from './basic-auth.filter';
var BasicAuthAuthenticator = /** @class */ (function () {
    function BasicAuthAuthenticator() {
        this.authFilter = new BasicAuthFilter();
    }
    BasicAuthAuthenticator.prototype.authenticate = function (req, resp, userModel) {
        this.authFilter.filter(req, userModel).subscribe(function (user) {
            if (user && !user.isAnonymous) {
                resp.status(204);
                resp.send();
            }
            else {
            }
        }, function (err) {
            resp.status(400);
            resp.json({
                reason: 'invalid authorization header'
            });
        });
    };
    return BasicAuthAuthenticator;
}());
export { BasicAuthAuthenticator };
//# sourceMappingURL=basic-auth.authenticator.js.map