import { Observable } from 'rxjs/Observable';
import { AuthFilterError } from '../../errors/auth-filter.error';
var Credentials = /** @class */ (function () {
    function Credentials() {
    }
    return Credentials;
}());
var BasicAuthFilter = /** @class */ (function () {
    function BasicAuthFilter() {
    }
    BasicAuthFilter.prototype.filter = function (req, userModel) {
        var _this = this;
        return Observable.create(function (observer) {
            try {
                var credentials = _this.getCredentials(req.headers.authorization);
                if (credentials) {
                    userModel.authenticate(credentials.login, credentials.password).subscribe(function (user) { return observer.next(user); }, function (err) { return observer.error(new AuthFilterError((err && (err.message || JSON.stringify(err)) || ''))); }, function () { return observer.complete(); });
                }
                else {
                    var user = new userModel();
                    user.isAnonymous = true;
                    observer.next(user);
                    observer.complete();
                }
            }
            catch (e) {
                observer.error(e);
                observer.complete();
            }
        });
    };
    BasicAuthFilter.prototype.getCredentials = function (authorization) {
        var credentials = null;
        if (authorization instanceof String) {
            var tokens = authorization.split(' ');
            if (tokens.length === 2 && tokens[0].toUpperCase() === 'BASIC' && tokens[1]) {
                var buf = new Buffer(tokens[1], 'base64');
                var plain_auth = buf.toString();
                var creds = plain_auth.split(':');
                if (creds && creds.length === 2) {
                    credentials = new Credentials();
                    credentials.login = creds[0];
                    credentials.password = creds[1];
                }
                else {
                    throw new AuthFilterError('Found authorization content with invalid encoded datas');
                }
            }
            else {
                throw new AuthFilterError('Found authorization content with invalid content');
            }
        }
        return credentials;
    };
    return BasicAuthFilter;
}());
export { BasicAuthFilter };
//# sourceMappingURL=basic-auth.filter.js.map