/// <reference types="express" />
import { DbHelperModuleConfig } from 'ts-db-helper';
import { IUserModel } from './interface/user-model.interface';
import { IAuthenticator } from './interface/authenticator.interface';
import { INamespace } from './interface/namespace.interface';
import { ViewSet } from './base/viewset';
import * as express from 'express';
import 'rxjs/add/operator/finally';
import 'rxjs/add/operator/switchMap';
import 'rxjs/add/Observable/empty';
export declare abstract class TsRestFrameworkApp {
    private static methods;
    private pathBase;
    private dbConfig;
    express: express.Application;
    constructor();
    private middleware();
    setAuthenticator(method: string, authPath: string, authenticator: IAuthenticator): void;
    private setDefaultAuthPermission(authPermission);
    private setDefaultPermissionFilter(permissionFilter);
    setUserModel(userModel: IUserModel): void;
    setPathBase(base: string): void;
    setDbConfig(config: DbHelperModuleConfig): void;
    import(view: {
        new (): INamespace | ViewSet<any>;
    }, parentPath?: string): TsRestFrameworkApp;
    private importViewset(mViewset, parentPath);
    private addRoute(mViewset, key, routeConfig, endPointConfig, router);
    private importNamespace(mNamespace, parentPath);
    private appendPath(parentPath, childPath);
    start(): void;
}
