"use strict";function Route(e){return function(t){var n=RouteManager.getInstance().getRouteBundle(t);n||(n=new RouteBundle,RouteManager.getInstance().addRouteBundle(t,n)),n.config=e}}function Namespace(e){return function(t){return RouteManager.getInstance().addNamespaceConfiguration(t,e),t}}function endPointFactory(e,t){return function(n,r,o){var i=RouteManager.getInstance().getRouteBundle(n);i||(i=new RouteBundle,RouteManager.getInstance().addRouteBundle(n,i)),t.method=e,i.routes[r]=t}}function Get(e){return endPointFactory("get",e)}function Post(e){return endPointFactory("post",e)}function Put(e){return endPointFactory("put",e)}function Patch(e){return endPointFactory("patch",e)}function Delete$1(e){return endPointFactory("delete",e)}function Options(e){return endPointFactory("options",e)}function Head(e){return endPointFactory("head",e)}function Connect(e){return endPointFactory("connect",e)}function All(e){return endPointFactory("all",e)}Object.defineProperty(exports,"__esModule",{value:!0});var rxjs_Observable=require("rxjs/Observable"),jwt=require("jsonwebtoken"),tsDbHelper=require("ts-db-helper"),express=require("express"),bodyParser=require("body-parser"),http=require("http");require("rxjs/add/operator/finally"),require("rxjs/add/operator/switchMap"),require("rxjs/add/Observable/empty");var PermissionResult=function(){function e(e){this.isOk=e||!1}return e}(),IsAutenticatedPermission=function(){function e(){}return e.prototype.check=function(e,t){return rxjs_Observable.Observable.create(function(t){t.next(new PermissionResult(!!e.user&&!e.user.isAnonymous)),t.complete()})},e}(),AnonymousPermission=function(){function e(){}return e.prototype.check=function(e,t){return rxjs_Observable.Observable.create(function(e){e.next(new PermissionResult(!0)),e.complete()})},e}(),NoAuthFilter=function(){function e(){}return e.prototype.filter=function(e,t){return rxjs_Observable.Observable.create(function(e){var n=new t;n.isAnonymous=!0,e.next(n),e.complete()})},e}(),NoAuthenticator=function(){function e(){this.authFilter=new NoAuthFilter}return e.prototype.authenticate=function(e,t,n){t.status(204),t.send(null)},e}(),AuthFilterError=function(){function e(e){this.message=e,this.name="Auth filter error"}return e}(),StringUtils=function(){function e(){}return e.isString=function(e){return"string"==typeof e||e instanceof String},e}(),Log=function(){function e(){}return Object.defineProperty(e,"logger",{get:function(){return e.loggerValue||(e.loggerValue=tsDbHelper.QueryManager.getInstance().logger),e.loggerValue},enumerable:!0,configurable:!0}),e.init=function(e){this.loggerValue=e},e.l=function(){for(var t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];(r=e.logger).log.apply(r,t);var r},e.d=function(){for(var t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];(r=e.logger).debug.apply(r,t);var r},e.t=function(){for(var t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];(r=e.logger).trace.apply(r,t);var r},e.i=function(){for(var t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];(r=e.logger).info.apply(r,t);var r},e.w=function(){for(var t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];(r=e.logger).warn.apply(r,t);var r},e.e=function(){for(var t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];(r=e.logger).error.apply(r,t);var r},e.f=function(){for(var t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];(r=e.logger).fatal.apply(r,t);var r},e}(),JWTFilter=function(){function e(e){this.config=e}return e.prototype.filter=function(e,t){var n=this;return rxjs_Observable.Observable.create(function(r){var o=e.headers[n.config.httpHeader.toLowerCase()],i=null,s=null;if(o&&StringUtils.isString(o))if(n.config.httpHeaderAuthType){var a=o.split(" ");2===a.length&&a[0].toUpperCase()===n.config.httpHeaderAuthType.toUpperCase()?i=a[1]:s='Token header do not conform to "'+n.config.httpHeaderAuthType+' <token>"'}else i=o;if(i){var u={};n.config.audience&&(u.audience=n.config.audience),n.config.algorithm&&(u.algorithm=n.config.algorithm),n.config.issuer&&(u.algorithm=n.config.algorithm),jwt.verify(i,n.config.secret,u,function(e,t){if(e)Log.e(e.message||JSON.stringify(e)),r.error(new AuthFilterError(e.name+": "+e.message));else if(t instanceof String)r.error(new AuthFilterError("Token has an invalid payload"));else if(t.user)try{var o=n.config.deserializeUser(t.user);r.next(o)}catch(e){Log.e(e.message||JSON.stringify(e)),r.error(new AuthFilterError("Token contains invalid user"))}r.complete()})}else{if(s)r.error(new AuthFilterError(s));else{var c=new t;c.isAnonymous=!0,r.next(c)}r.complete()}})},e}(),JWTConfiguration=function(){function e(){this.expiresIn=86400,this.httpHeader="Authorization",this.httpHeaderAuthType="JWT",this.issuer="trf-app:issuer",this.audience="trf-app:audience"}return e}(),JWTAuthenticator=function(){function e(e){this.config=e,this.authFilter=new JWTFilter(this.config)}return e.prototype.authenticate=function(e,t,n){var r=this,o=e.body;o&&o.username&&o.password?n.authenticate(o.username,o.password).subscribe(function(e){if(!e||e.isAnonymous)t.status(400),t.json({reason:"Invalid credentials"});else{var n=r.config.serializeUser(e),o={};r.config.algorithm&&(o.algorithm=r.config.algorithm),r.config.audience&&(o.audience=r.config.audience),r.config.issuer&&(o.issuer=r.config.issuer);try{var i=jwt.sign({user:n},r.config.secret,o);t.status(200),t.json({token:i})}catch(e){t.status(500),t.json({reason:"Token creation did fail",details:e.message||JSON.stringify(e)})}}},function(e){var n={reason:""};e instanceof String?n.reason=e:e&&e.message?n.reason=e.message:n.reason=JSON.stringify(e),t.status(500),t.json(n)}):(t.status(400),t.json({reason:"Username, password or both are missing in message body"}))},e}(),Credentials=function(){function e(){}return e}(),BasicAuthFilter=function(){function e(){}return e.prototype.filter=function(e,t){var n=this;return rxjs_Observable.Observable.create(function(r){try{var o=n.getCredentials(e.headers.authorization);if(o)t.authenticate(o.login,o.password).subscribe(function(e){return r.next(e)},function(e){return r.error(new AuthFilterError(e&&(e.message||JSON.stringify(e))||""))},function(){return r.complete()});else{var i=new t;i.isAnonymous=!0,r.next(i),r.complete()}}catch(e){r.error(e),r.complete()}})},e.prototype.getCredentials=function(e){var t=null;if(e instanceof String){var n=e.split(" ");if(2!==n.length||"BASIC"!==n[0].toUpperCase()||!n[1])throw new AuthFilterError("Found authorization content with invalid content");var r=new Buffer(n[1],"base64"),o=r.toString(),i=o.split(":");if(!i||2!==i.length)throw new AuthFilterError("Found authorization content with invalid encoded datas");t=new Credentials,t.login=i[0],t.password=i[1]}return t},e}(),BasicAuthAuthenticator=function(){function e(){this.authFilter=new BasicAuthFilter}return e.prototype.authenticate=function(e,t,n){this.authFilter.filter(e,n).subscribe(function(e){e&&!e.isAnonymous&&(t.status(204),t.send())},function(e){t.status(400),t.json({reason:"invalid authorization header"})})},e}(),IUser=function(){function e(){}return e}(),RouteManager=function(){function e(){this.bundles={},this.namespacies={}}return e.getInstance=function(){return e.instance||(e.instance=new e),e.instance},e.prototype.addRouteBundle=function(e,t){if(this.bundles.hasOwnProperty(e.name||e.constructor.name))throw new Error("Duplicate adding viewSet to route manager");this.bundles[e.name||e.constructor.name]=t},e.prototype.getRouteBundle=function(e){return this.bundles[e.name||e.constructor.name]},e.prototype.addNamespaceConfiguration=function(e,t){if(this.bundles.hasOwnProperty(e.name))throw new Error("Duplicate adding viewSet to route manager");this.namespacies[e.name]=t||null},e.prototype.getNamespaceConfiguration=function(e){var t=this.namespacies[e.name];if(t)return t;throw new Error('Namespace "'+e.name+'" is not correctly declared, did you use @Namespace ?')},e.prototype.isRegisteredNamespace=function(e){return this.namespacies.hasOwnProperty(e.name)},e.prototype.isRegisteredViewset=function(e){return this.bundles.hasOwnProperty(e.name)},e}(),RouteBundle=function(){function e(){this.routes={}}return e}(),RouteConfigurator=function(){function e(){}return e}(),NamespaceConfigurator=function(){function e(){this.views=[]}return e}(),EndPointConfigurator=function(){function e(){}return e}(),Page=function(){function e(){}return e.prototype.isLast=function(){return this.totalElementsCount<=(this.number+1)*this.size},e}(),ViewSet=function(){function e(){this.query||(this.query=tsDbHelper.Select(this.model).setSize(50)),this.serializer||(this.serializer=tsDbHelper.AutoSerializer)}return e.prototype.search=function(e,t){},e.prototype.list=function(e,t){var n=this,r=!1;if(e.query.size){var o=parseInt(e.query.pageSize,10);isNaN(o)?(t.status(400),t.json({reason:"Invalid page size"}),r=!0):this.query.setSize(o)}if(e.query.page){var i=parseInt(e.query.pageNumber,10);isNaN(i)?(t.status(400),t.json({reason:"Invalid page number"}),r=!0):this.query.setPage(i)}r||tsDbHelper.Count(this.query).exec().subscribe(function(e){var r=new Page;if(0===e)return r.number=0,r.size=0,r.total=0,r.totalElementsCount=0,r.content=[],t.status(200),void t.json(r);var o=e/n.query.getSize(),i=Math.floor(o);o===i&&(i-=1),n.query.getPage()<=i?n.query.exec().subscribe(function(o){if(r.number=n.query.getPage(),r.size=n.query.getSize(),r.total=i+1,r.totalElementsCount=e,o.rows.length){n.getSerializerInstance(o.rows.toArray(),!0).getData().subscribe(function(e){r.content=e,t.status(200),t.json(r)},function(e){t.status(500),t.json({reason:"an error occurred while serializing retrieved datas",details:e})})}else r.content=[],t.status(200),t.json(r)},function(e){t.status(500),t.json({reason:"Cannot fetch results",details:e})}):(t.status(400),t.json({reason:"This page is out of range",min:0,max:i}))},function(e){t.status(500),t.json({reason:'Cannot count total "'+n.model.name+'" count',details:e})})},e.prototype.retrieve=function(e,t){this.retrieveOrDelete(e,t,!0)},e.prototype.create=function(e,t){this.persist(e,t,!0)},e.prototype.update=function(e,t){this.persist(e,t,!1)},e.prototype.partialUpdate=function(e,t){this.persist(e,t,!1,!0)},e.prototype.delete=function(e,t){this.retrieveOrDelete(e,t,!1)},e.prototype.retrieveOrDelete=function(e,t,n){for(var r=this,o=tsDbHelper.ModelManager.getInstance().getModel(this.model).columnList,i={},s=null,a=[],u=0,c=o;u<c.length;u++){var l=c[u];l.primaryKey&&(e.params.hasOwnProperty(l.field)?l.autoIncrement&&null===e.params[l.field]||void 0===e.params[l.field]?(s=!0,a.push(l.field)):(null===s&&(s=!1),i[l.name]=e.params[l.field]):(s=!0,a.push(l.field)))}s?(t.status(400),t.json({reason:"A primary key is missing or invalid",invalidFields:a})):n?tsDbHelper.Select(this.model).where(i).exec().subscribe(function(e){if(0===e.rows.length)t.status(404),t.json({reason:"Ressource not found"});else{r.getSerializerInstance(e.rows.item(0),!1).getData().subscribe(function(e){t.status(200),t.json(e)},function(e){t.status(500),t.json({reason:"failed to serialize"})})}},function(e){t.status(500),t.json({reason:"Retrieve element did fail",details:e})}):tsDbHelper.Delete(this.model).where(i).exec().subscribe(function(){t.status(204),t.send()},function(e){t.status(500),t.json({reason:"Delete query did fail",details:e})})},e.prototype.getSerializerInstance=function(e,t){return this.serializer===tsDbHelper.AutoSerializer?new this.serializer(this.model,e,t):new this.serializer(e,t)},e.prototype.persist=function(e,t,n,r){var o=this,i=e.body;if(i&&!Array.isArray(i)){var s=this.getSerializerInstance(i,!1);r&&s.setPartialParse(!0),s.getInstance().subscribe(function(e){return e.checkIfShouldUpdateFromDatabase().subscribe(function(r){var i;r&&n?(t.status(400),t.json({reason:'Cannot create "'+o.model.name+'", a model whith the same primary key already exists'})):!r&&n?(t.status(400),t.json({reason:"Cannot update instance, primary keys are not valid or model should be created first"})):i=r?e.update().map(function(){return!0}):e.insert().map(function(){return!0}),i&&i.subscribe(function(n){return o.getSerializerInstance(e,!1).getData().subscribe(function(e){t.status(201),t.json(e)},function(e){t.status(500),t.json({reason:"Deserialization of saved instance failed",details:e})})},function(e){t.status(400),t.json({reason:"save instance did fail",error:e})})},function(e){t.status(500),t.json({reason:"Fail to check if model already exists",details:e})})},function(e){e instanceof tsDbHelper.SerializerError?(t.status(400),t.json({reason:"one or many fields are not valid",serializationMessage:e.message,details:e.fieldErrors})):(t.status(500),t.json({reason:"Uncaught serialize error happened"}))})}else t.status(400),t.json({reason:"Request body contains anything or an array. Only a json object is expected"})},e}(),EndPointBuilder=function(){function e(){}return e.build=function(t,n,r,o,i){var s=o.method.toUpperCase()+" "+r.path+o.path+" => "+t.name+"."+n;return Log.i(s),function(i,a,u){Log.d(s),i.body&&Log.d("body: "+JSON.stringify(i.body));try{var c=new t;e.manageEndPointAuthFilter(i,a,r,o,c,n)}catch(e){Log.e(e),a.status(500),a.json({reason:"Unhandled error",details:e})}}},e.manageEndPointError=function(e,t,n){n instanceof AuthFilterError?(t.status(401),t.json({reason:"Invalid request authentication informations",details:n.message})):(Log.e(n),t.status(500),t.json({reason:"Unhandled error",details:n instanceof String?n:n.toString()}))},e.manageEndPointAuthFilter=function(t,n,r,o,i,s){var a,u;e.callEndPointAuthFilter(t,r,o).finally(function(){u?e.manageEndPointError(t,n,u):(a&&(t.user=a),e.manageEndPointAuthPermission(t,n,r,o,i,s))}).subscribe(function(e){a=e},function(e){Log.e(u),u=e})},e.callEndPointAuthFilter=function(t,n,r){var o=[],i=r.authFilter||n.authFilter;if(i&&(Log.d(r.authFilter?r.authFilter.constructor.name:"no enpoint filter"),Log.d(n.authFilter?n.authFilter.constructor.name:"no route filter"),o.push(i)),o.length||(o=o.concat(e.authFilters)),n.addAuthFilters&&(o=o.concat(n.addAuthFilters)),r.addAuthFilters&&(o=o.concat(r.addAuthFilters)),o.length)return e.scanAuthFilters(t,o);var s=new e.userModel;return s.isAnonymous=!0,rxjs_Observable.Observable.from([s])},e.scanAuthFilters=function(t,n,r){return void 0===r&&(r=0),n[r].filter(t,e.userModel).switchMap(function(o){return!o&&r<n.length-1?e.scanAuthFilters(t,n,r+1):rxjs_Observable.Observable.create(function(e){e.next(o),e.complete()})})},e.manageEndPointAuthPermission=function(t,n,r,o,i,s){var a,u;e.callAuthPermissions(t,r,o).finally(function(){u?e.manageEndPointError(t,n,u):!a||a.isOk?e.manageEndPointPermissions(t,n,r,o,i,s):(n.status(401),n.json({reason:"Request not authenticated",details:a?a.rejectionReason:""}))}).subscribe(function(e){a=e},function(e){u=e})},e.callAuthPermissions=function(t,n,r){var o=r.authPermission||n.authPermission||e.defaultAuthPermission;return o?o.check(t,e.userModel):rxjs_Observable.Observable.create(function(e){e.next(new PermissionResult(!0)),e.complete()})},e.manageEndPointPermissions=function(t,n,r,o,i,s){var a,u;e.callPermissions(t,r,o).finally(function(){if(u)e.manageEndPointError(t,n,u);else if(!a||a.isOk)try{i[s](t,n)}catch(r){e.manageEndPointError(t,n,r)}else n.status(403),n.json({reason:"Request not authorized",details:a?a.rejectionReason:""})}).subscribe(function(e){a=e},function(e){u=e})},e.callPermissions=function(t,n,r){var o=[],i=r.permissionFilter||n.permissionFilter||e.defaultPermissionFilter;return i&&o.push(i),n.addPermissionFilters&&(o=o.concat(n.addPermissionFilters)),r.addPermissionFilters&&(o=o.concat(r.addPermissionFilters)),o.length?e.scanPermissionFilters(t,o,0):rxjs_Observable.Observable.empty()},e.scanPermissionFilters=function(t,n,r){return n[r].filter(t,e.userModel).switchMap(function(o){return o.isOk&&r<n.length-1?e.scanPermissionFilters(t,n,r+1):rxjs_Observable.Observable.create(function(e){e.next(o),e.complete()})})},e.authFilters=[],e}(),Express=express,TsRestFrameworkApp=function(){function e(){this.pathBase="/",this.express=Express()}return e.prototype.middleware=function(){this.express.use(function(e,t,n){n()}),this.express.use(bodyParser.json()),this.express.use(bodyParser.urlencoded({extended:!1}))},e.prototype.setAuthenticator=function(t,n,r){if(r&&n){var o=express.Router();if(o.use(bodyParser.json()),o.use(bodyParser.urlencoded({extended:!1})),-1===e.methods.indexOf(t.toLowerCase()))throw new Error("Try to add auth point with unknown method value: "+t);o[t]("/",function(e,t,n){r.authenticate(e,t,EndPointBuilder.userModel)}),this.express.use(n,o)}r&&r.authFilter&&EndPointBuilder.authFilters.push(r.authFilter),EndPointBuilder.defaultAuthPermission=new IsAutenticatedPermission},e.prototype.setDefaultAuthPermission=function(e){EndPointBuilder.defaultAuthPermission=e},e.prototype.setDefaultPermissionFilter=function(e){EndPointBuilder.defaultPermissionFilter=e},e.prototype.setUserModel=function(e){EndPointBuilder.userModel=e},e.prototype.setPathBase=function(e){this.pathBase=e,"/"!==this.pathBase[0]&&(this.pathBase="/"+this.pathBase)},e.prototype.setDbConfig=function(e){this.dbConfig=e},e.prototype.import=function(e,t){if(void 0===t&&(t=this.pathBase),RouteManager.getInstance().isRegisteredNamespace(e))this.importNamespace(e,this.pathBase);else{if(!RouteManager.getInstance().isRegisteredViewset(e))throw new Error('"'+e.name+'" is not registered did you miss "@Namespace" or "@Route" annotation ?');this.importViewset(e,this.pathBase)}return this},e.prototype.importViewset=function(e,t){var n=RouteManager.getInstance().getRouteBundle(e);if(!n)throw new Error('ViewSet "'+e.name+'" has no configuration, did you miss "@Route" decorator on this ViewSet ?');var r=express.Router(),o=this.appendPath(t,n.config.path);if(n.config.middlewares&&n.config.middlewares.length)for(var i=0,s=n.config.middlewares;i<s.length;i++){var a=s[i];r.use(a)}else r.use(bodyParser.json()),r.use(bodyParser.urlencoded({extended:!1}));for(var u in n.routes)if(n.routes.hasOwnProperty(u)){var c=n.routes[u];this.addRoute(e,u,n.config,c,r)}this.express.use(o,r)},e.prototype.addRoute=function(t,n,r,o,i){o.path&&"/"===o.path[0]||(o.path="/"+o.path),o.method=o.method||"get";var s=EndPointBuilder.build(t,n,r,o,i);if(-1===e.methods.indexOf(o.method.toLowerCase()))throw new Error("Try to add end point with unknown method");i[o.method](o.path,s)},e.prototype.importNamespace=function(e,t){var n=RouteManager.getInstance().getNamespaceConfiguration(e);n.path=n.path||"";for(var r=this.appendPath(t,n.path),o=0,i=n.views;o<i.length;o++){var s=i[o];this.import(s,r)}},e.prototype.appendPath=function(e,t){return t?"/"===e[e.length-1]&&"/"===t[0]?e+t.substr(1,t.length):"/"===e[e.length-1]||"/"===t[0]?e+t:e+"/"+t:e},e.prototype.start=function(){function e(e){if("listen"!==e.syscall)throw e;var t="string"==typeof n?"Pipe "+n:"Port "+n;switch(e.code){case"EACCES":Log.e(t+" requires elevated privileges"),process.exit(1);break;case"EADDRINUSE":Log.e(t+" is already in use"),process.exit(1);break;default:throw e}}function t(){var e=r.address(),t="string"==typeof e?"pipe "+e:"port "+e.port;Log.i("Listening on "+t)}tsDbHelper.QueryManager.init(this.dbConfig);var n=function(e){var t="string"==typeof e?parseInt(e,10):e;return isNaN(t)?e:t>=0&&t}(process.env.PORT||3e3);this.express.set("port",n);var r=http.createServer(this.express);r.listen(n),r.on("error",e),r.on("listening",t)},e.methods=["get","post","put","patch","delete","options","head","connect","trace","all"],e}();exports.IsAutenticatedPermission=IsAutenticatedPermission,exports.AnonymousPermission=AnonymousPermission,exports.NoAuthenticator=NoAuthenticator,exports.NoAuthFilter=NoAuthFilter,exports.JWTFilter=JWTFilter,exports.JWTConfiguration=JWTConfiguration,exports.JWTAuthenticator=JWTAuthenticator,exports.BasicAuthFilter=BasicAuthFilter,exports.BasicAuthAuthenticator=BasicAuthAuthenticator,exports.PermissionResult=PermissionResult,exports.IUser=IUser,exports.AuthFilterError=AuthFilterError,exports.Route=Route,exports.Namespace=Namespace,exports.All=All,exports.Connect=Connect,exports.Delete=Delete$1,exports.Get=Get,exports.Head=Head,exports.Options=Options,exports.Patch=Patch,exports.Post=Post,exports.Put=Put,exports.RouteConfigurator=RouteConfigurator,exports.NamespaceConfigurator=NamespaceConfigurator,exports.EndPointConfigurator=EndPointConfigurator,exports.ViewSet=ViewSet,exports.TsRestFrameworkApp=TsRestFrameworkApp;